#include "mc9s08js16.h"

// const unsigned char __at 0xffba byp = 0x00;
// uncomment the above to bypass the bootloader CRC check

void MCG_Init(void);


void mtim_interrupt(void) __interrupt 26
{
  __data static char a=0;
  a++;
  if(a>3) {
    PTBD_PTBD3 = !PTBD_PTBD3;
    a=0;
  } 
  MTIMSC=0x60; // enable MTIM interrupts, reset counter
}


void main(void)
{
  
  SOPT1_COPT=0; // disable watchdog
  
  // high drive on PTBD3
  PTBD_PTBD3=1;
  PTBDS_PTBDS3=1;
  
  MCG_Init();
  
  MTIMCLK=0x18; // src = xclk, /256
  MTIMSC=0x60; // enable MTIM interrupts, reset counter
  
  //  EnableInterrupts;
  __asm
    cli
  __endasm;

  for(;;) {
    //    __RESET_WATCHDOG();	/* feeds the dog */
  } /* loop forever */

}

// 12 / 8 * 32
#define RDIV (3<<3)
#define VDIV 8
//#define TRDIV (7<<3)

void MCG_Init(void)
{
  MCGC2 = 0x36;
  while(!MCGSC_OSCINIT);            // wait for the OSC stable (0x02)
  MCGC1 = 0x80|RDIV;
  while((MCGSC & 0x1C ) != 0x08);   // check the external reference clock is selected or not
  MCGC3 = 0x40|VDIV;
  while ((MCGSC & 0x48) != 0x48);   //wait for the PLL lock
  
  // PBE -> PEE
  //	MCGC1 = RDIV; // clear bit 6 and 7
  MCGC1_CLKS1=0; // since only bit 7 was set above bitclr can be used (saves one byte)
  while((MCGSC & 0x6C) != 0x6C);
}
